-- C:\WORK\HDL\SAMPLE\ASB004_12\SELF_RST_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 4.1i
-- Fri Oct 18 18:15:22 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT SELF_RST
		PORT (
			CLK : in  std_logic;
			RST : in  std_logic;
			ENB : in  std_logic;
			DATA : in  std_logic_vector (7 DOWNTO 0);
			L : out  std_logic_vector (1 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL ENB : std_logic;
	SIGNAL DATA : std_logic_vector (7 DOWNTO 0);
	SIGNAL L : std_logic_vector (1 DOWNTO 0);

BEGIN
	UUT : SELF_RST
	PORT MAP (
		CLK => CLK,
		RST => RST,
		ENB => ENB,
		DATA => DATA,
		L => L
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 10 ns;
		CLK <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 17 ns;
		CLK <= transport '0';
		WAIT FOR 17 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_L(
			next_L : std_logic_vector (1 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (L /= next_L) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns L="));
				write(TX_LOC, L);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_L);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		RST <= transport '1';
		ENB <= transport '0';
		DATA <= transport std_logic_vector'("00000000"); --0
		-- --------------------
		WAIT FOR 54 ns; -- Time=54 ns
		RST <= transport '0';
		-- --------------------
		WAIT FOR 54 ns; -- Time=108 ns
		ENB <= transport '1';
		DATA <= transport std_logic_vector'("00101010"); --2A
		-- --------------------
		WAIT FOR 54 ns; -- Time=162 ns
		ENB <= transport '0';
		-- --------------------
		WAIT FOR 108 ns; -- Time=270 ns
		ENB <= transport '1';
		DATA <= transport std_logic_vector'("11011101"); --DD
		-- --------------------
		WAIT FOR 54 ns; -- Time=324 ns
		ENB <= transport '0';
		-- --------------------
		WAIT FOR 2521 ns; -- Time=2845 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION SELF_RST_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END SELF_RST_cfg;
